<template>
  <div id="q-app">
    <q-overlay v-model="showOverlay" :z-index="5000" no-scroll>
      <template #body>
        <div class="fullscreen row justify-center items-center">
          <div class="column">
            <q-btn
              no-caps
              outline
              color="deep-purple-13"
              style="background-color: white !important;"
              label="Sign in with Blockstack"
              @click="signInBlockstack"
              icon="img:/statics/images/blockstack.svg"
            ></q-btn>
          </div>
        </div>
      </template>
      <router-view />
    </q-overlay>
  </div>
</template>

<script>
import { userSession } from "boot/blockstack";
import { mapActions } from "vuex";
import { authenticate } from "@blockstack/connect";

export default {
  name: "App",
  data() {
    return {
      showOverlay: true
    };
  },
  mounted() {
    if (userSession.isUserSignedIn()) {
      this.initBlockstack();
      this.showOverlay = false;
    } else if (userSession.isSignInPending()) {
      userSession.handlePendingSignIn().then(() => {
        this.initBlockstack();
        this.showOverlay = false;
      });
    } else {
      this.showOverlay = true;
    }
  },
  methods: {
    ...mapActions(["initBlockstack"]),
    signInBlockstack() {
      const authOptions = {
        appDetails: {
          name: "Hoverlook",
          icon: "https://hoverlook.app/statics/icons/icon-256x256.png"
        },
        finished: async () => {
          this.initBlockstack();
          this.showOverlay = false;
        }
      };
      authenticate(authOptions);
    }
  }
};
</script>
<style>
.text-strikethrough {
  text-decoration: line-through;
}
</style>
